<?php
/**
*
* FIND - Atom/RSS import
*
* @package acp
* @version 0.2r3
* @copyright (c) 2008, 2009 PoPoutdoor
* @license	http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_find
{
	var $u_action;

	function main($id, $mode)
	{
		global $config, $db, $user, $auth, $template, $cache;
		global $phpbb_root_path, $phpbb_admin_path, $phpEx, $table_prefix;

		$action = request_var('action', '');
		$submit = (isset($_POST['submit'])) ? true : false;
		$mark	= request_var('mark', array(0));
		$feed_id = request_var('id', 0);

		if (isset($_POST['add']))
		{
			$action = 'add';
		}

		$error = array();

		$user->add_lang('mods/acp_find');
		$this->tpl_name = 'acp_find';
		$this->page_title = 'ACP_FIND';
		$form_key = 'acp_find';
		add_form_key($form_key);

		if ($submit && !check_form_key($form_key))
		{
			$error[] = $user->lang['FORM_INVALID'];
		}

		// User wants to do something, how inconsiderate of them!
		switch ($action)
		{
			case 'activate':
			case 'deactivate':
				if ($feed_id || sizeof($mark))
				{
					$sql_id = ($feed_id) ? " = $feed_id" : ' IN (' . implode(', ', $mark) . ')';
					$activate = ($action == 'activate') ? 1 : 0;

					$sql = 'UPDATE ' . FIND_TABLE . "
						SET feed_active = $activate
						WHERE feed_id $sql_id";
					$db->sql_query($sql);
				}

				$db->sql_transaction('commit');

				$cache->destroy('_find');
			break;

			case 'import':
				if ($feed_id || sizeof($mark))
				{
					$ids = ($feed_id) ? $feed_id : implode(',', $mark);

					include_once($phpbb_root_path . 'includes/rss_parser.' . $phpEx);
					include_once($phpbb_root_path . 'includes/functions_find.' . $phpEx);

					// We use Bot language here
					$ret = get_rss_content($ids);
					// Current user language restored

					// process returned message
					$msg_ary = array('OK', 'SKIP', 'ERR');
					$message = '';
					foreach ($msg_ary as $not_use => $msg)
					{
						$message .= $user->lang['IMPORT_' . $msg];
						$msg = strtolower($msg);
						if (empty($ret[$msg]))
						{
							$message .= $user->lang['NONE'];
						}
						else
						{
							$message .= "\n\n";
							foreach ($ret[$msg] as $key => $text)
							{
								$message .= "    $text\n";
							}
						}
					}

					trigger_error(generate_text_for_display($message, null,null, null) . adm_back_link($this->u_action));

				}
				else
				{
					trigger_error( $user->lang['NO_FEED'] . adm_back_link($this->u_action));
				}
			break;

			case 'delete':
				if ($feed_id || sizeof($mark))
				{
					if (confirm_box(true))
					{
						// We need to delete the relevant feed entries ...
						$sql_id = ($feed_id) ? " = $feed_id" : ' IN (' . implode(', ', $mark) . ')';

						// fetch data for logging						
						$sql = 'SELECT feed_name
							FROM ' . FIND_TABLE . "
							WHERE feed_id $sql_id";
						$result = $db->sql_query($sql);

						$feed_name_ary = array();
						while ($rss_row = $db->sql_fetchrow($result))
						{
							$feed_name_ary[] = $rss_row['feed_name'];
						}
						$rss_row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);

						// delete data from db
						$db->sql_transaction('begin');

						$sql = 'DELETE FROM ' . FIND_TABLE . "
							WHERE feed_id $sql_id";
						$db->sql_query($sql);

						$db->sql_transaction('commit');

						$cache->destroy('_find');

						add_log('admin', 'LOG_FEED_DELETE', implode(', ', $feed_name_ary));
						trigger_error( $user->lang['FEED_DELETED'] . adm_back_link($this->u_action));
					}
					else
					{
						confirm_box(false, $user->lang['CONFIRM_OPERATION'], build_hidden_fields(array(
							'mark'	=> $mark,
							'id'		=> $feed_id,
							'mode'	=> $mode,
							'action'	=> $action))
						);
					}
				}
			break;

			case 'edit':
			case 'add':
				// Build forum ids
				$sql = 'SELECT forum_id, forum_type
					FROM ' . FORUMS_TABLE . '
					ORDER BY left_id';
				$result = $db->sql_query($sql);

				$forum_id = $ignore_id = array();
				while ($row = $db->sql_fetchrow($result))
				{
					$forum_id[] = (int) $row['forum_id'];
					if ($row['forum_type'] != FORUM_POST)
					{
						$ignore_id[] = (int) $row['forum_id'];
					}
				}
				$db->sql_freeresult($result);

				// Build RSS bot list
				$sql = 'SELECT user_id, username
					FROM ' . USERS_TABLE . '
					WHERE username LIKE "%RSS Bot%"';
				$result = $db->sql_query($sql);

				$bot_list = array();
				while ($row = $db->sql_fetchrow($result))
				{
					$bot_list[$row['user_id']] = $row['username'];
				}
				$db->sql_freeresult($result);

				// init/normalise form values
				$rss_row = array(
				//	'feed_active'		=> request_var('feed_active', false),
					'feed_name'			=> utf8_normalize_nfc(request_var('feed_name', '', true)),
					'feed_url'			=> request_var('feed_url', ''),
					'feed_limit'		=> request_var('feed_limit', 0),
					'post_forum'		=> request_var('post_forum', 0),
					'robot_id'			=> request_var('robot_id', 0),
					'post_limit'		=> request_var('post_limit', 0),
					'feed_channel'		=> request_var('feed_channel', true),
					'feed_image'		=> request_var('feed_image', true),
					'feed_contents'	=> request_var('feed_contents', true),
					'feed_recode'		=> utf8_normalize_nfc(request_var('feed_recode', '', true)),
					'post_feedname'	=> request_var('post_feedname', false),
				);

				if ($action == 'add')
				{
					$l_title = 'ADD';
					$select_id = false;
					$robot_id = 0;
				}
				else if ($feed_id)
				{
					// fetch data for edit
					if (!$submit)
					{
						$sql = 'SELECT *
							FROM ' . FIND_TABLE . "
							WHERE feed_id = $feed_id";
						$result = $db->sql_query($sql);
						$rss_row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);

						if (!$rss_row)
						{
							$error[] = $user->lang['NO_FEED_ENTRIES'];
						}
					}

					$l_title = 'EDIT';
					$select_id = $rss_row['post_forum'];
					$robot_id = $rss_row['robot_id'];
				}

				// Build forum options
				$forum_list = make_forum_select($select_id, $ignore_id, true, false, false, false, true);

				$s_forum_options = '<option value="0">--- ' . $user->lang['POST_FORUM'] . ' ---</option>';
				foreach ($forum_list as $key => $row)
				{
					if ($row['disabled'])
					{
						$s_forum_options .= '<option disabled="disabled" class="disabled-option">';
					}
					else
					{
						$s_forum_options .= '<option value="' . $row['forum_id'] . '"' . (($row['selected']) ? ' selected="selected"' : '') . '>';
					}

					$s_forum_options .= $row['padding'] . $row['forum_name'] . '</option>';
				}

				// Build RSS bot options
				$s_bot_options = '<option value="0">--- ' . $user->lang['POST_BOT'] . ' ---</option>';
				foreach ($bot_list as $id => $name)
				{
					$s_bot_options .= '<option value="' . $id . (($id == $robot_id) ? '" selected="selected" >' : '" >') . $name . '</option>';
				}

				$s_ = array();
				$toggle_ary = array('post_feedname', 'feed_channel', 'feed_image', 'feed_contents');
				$_options = array('0' => 'NO', '1' => 'YES');
				foreach ($toggle_ary as $not_use => $form_key)
				{
					$s_options = '';
					foreach ($_options as $value => $lang)
					{
						$selected = ($rss_row[$form_key] == $value) ? ' selected="selected"' : '';
						$s_options .= '<option value="' . $value . '"' . $selected . '>' . $user->lang[$lang] . '</option>';
					}

					$s_[$form_key] = $s_options;
				}

				if ($submit)
				{
					// validate form
					if (!$rss_row['post_forum'])
					{
						$error[] = $user->lang['NO_FORUM'];
					}

					if (!$rss_row['robot_id'])
					{
						$error[] = $user->lang['NO_USER'];
					}

					if (empty($rss_row['feed_name']))
					{
						$error[] = $user->lang['NO_FEED_NAME'];
					}
					else if (utf8_strlen(htmlspecialchars_decode($rss_row['feed_name'])) < 3)
					{
						$error[] = $user->lang['NAME_TOO_SHORT'];
					}
					else if (utf8_strlen(htmlspecialchars_decode($rss_row['feed_name'])) > 255)
					{
						$error[] = $user->lang['NAME_TOO_LONG'];
					}

					if (empty($rss_row['feed_url']))
					{
						$error[] = $user->lang['NO_FEED_URL'];
					}
					else if (utf8_strlen(htmlspecialchars_decode($rss_row['feed_url'])) < 3)
					{
						$error[] = $user->lang['URL_TOO_SHORT'];
					}
					else if (utf8_strlen(htmlspecialchars_decode($rss_row['feed_url'])) > 255)
					{
						$error[] = $user->lang['URL_TOO_LONG'];
					}
					else if (!preg_match('#^http[s]?://(.*?\.)*?[a-z0-9\-]+\.[a-z]{2,4}#i', htmlspecialchars_decode($rss_row['feed_url'])))
					{
						$error[] = $user->lang['URL_NOT_VALID'];
					}

					if (!empty($rss_row['feed_recode']) && utf8_strlen(htmlspecialchars_decode($rss_row['feed_recode'])) > 32)
					{
						$error[] = $user->lang['ENCODE_TOO_LONG'];
					}

					if (!sizeof($error))
					{
						$sql_ary = array(
						//	'feed_active'		=> (int) $rss_row['feed_active'],
							'feed_channel'		=> (int) $rss_row['feed_channel'],
							'feed_contents'	=> (int) $rss_row['feed_contents'],
							'feed_image'		=> (int) $rss_row['feed_image'],
							'feed_limit'		=> (int) $rss_row['feed_limit'],
							'feed_name'			=> (string) $rss_row['feed_name'],
							'feed_recode'		=> (string) strtolower($rss_row['feed_recode']),
							'feed_url'			=> (string) $rss_row['feed_url'],
							'post_forum'		=> (int) $rss_row['post_forum'],
							'post_limit'		=> (int) $rss_row['post_limit'],
							'robot_id'			=> (int) $rss_row['robot_id'],
							'post_feedname'	=> (int) $rss_row['post_feedname'],
						);

						// New feed? Create a new entry
						if ($action == 'add')
						{
							$sql = 'INSERT INTO ' . FIND_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
							$db->sql_query($sql);

							$log = 'ADDED';
						}
						else if ($feed_id)
						{
							$sql = 'UPDATE ' . FIND_TABLE . '
								SET ' . $db->sql_build_array('UPDATE', $sql_ary) . " 
								WHERE feed_id = $feed_id";
							$db->sql_query($sql);

							$log = 'UPDATED';
						}

						$db->sql_transaction('commit');

						$cache->destroy('_find');
						
						add_log('admin', 'LOG_FEED_' . $log, $rss_row['feed_name']);
						trigger_error( $user->lang['FEED_' . $log] . adm_back_link($this->u_action));
					}
				}

				$template->assign_vars(array(
					'L_TITLE'		=> $user->lang[$l_title . '_FEED'],

					'ERROR_MSG'		=> (sizeof($error)) ? implode('<br />', $error) : '',
					
					'FEED_LIMIT'	=> $rss_row['feed_limit'],
					'FEED_NAME'		=> $rss_row['feed_name'],
					'FEED_RECODE'	=> $rss_row['feed_recode'],
					'FEED_URL'		=> $rss_row['feed_url'],
					'POST_LIMIT'	=> $rss_row['post_limit'],
					
				//	'S_ACTIVE_OPTIONS'	=> $s_['feed_active'],
					'S_BOT_OPTIONS'		=> $s_bot_options,
					'S_CHANNEL_OPTIONS'	=> $s_['feed_channel'],
					'S_CONTENTS_OPTIONS'	=> $s_['feed_contents'],
					'S_EDIT_FEED'			=> true,
					'S_ERROR'				=> (sizeof($error)) ? true : false,
					'S_FEEDNAME_OPTIONS'	=> $s_['post_feedname'],
					'S_FORUM_OPTIONS'		=> $s_forum_options,
					'S_IMAGE_OPTIONS'		=> $s_['feed_image'],

					'U_ACTION'	=> $this->u_action . "&amp;id=$feed_id&amp;action=$action",
					'U_BACK'		=> $this->u_action,
				));

				return;
			break;
		}

		$sql = 'SELECT r.*, f.forum_name, f.forum_parents  
			FROM ' . FIND_TABLE . ' r, ' . FORUMS_TABLE . ' f 
			WHERE r.post_forum = f.forum_id
			ORDER BY r.post_forum, r.feed_id ASC';
		$result = $db->sql_query($sql);

		$last_fid = 0;
		while ($row = $db->sql_fetchrow($result))
		{
			$tree = '';
			$s_tree = false;

			if ($last_fid != $row['post_forum'])
			{
				$s_tree = true;
				$last_fid = $row['post_forum'];

				$parents = unserialize($row['forum_parents']);
				foreach ($parents as $key)
				{
					$tree .= $key[0] . '<strong>&nbsp;&#8249;&nbsp;</strong>';
				}
				$tree .= $row['forum_name'];
			}

			$active_lang = (!$row['feed_active']) ? 'ACTIVATE' : 'DEACTIVATE';
			$active_value = (!$row['feed_active']) ? 'activate' : 'deactivate';

			$template->assign_block_vars('feeds', array(
				'S_TREE'	=> $s_tree,
				'FORUM'	=> $tree,

				'ID'				=> $row['feed_id'],
				'LAST_VISIT'	=> ($row['last_visit']) ? $user->format_date($row['last_visit']) : $user->lang['NEVER'],
				'NAME'			=> $row['feed_name'],
				'URL'				=> $row['feed_url'],

				'L_ACTIVATE_DEACTIVATE'	=> $user->lang[$active_lang],
				'U_ACTIVATE_DEACTIVATE'	=> $this->u_action . "&amp;id={$row['feed_id']}&amp;action=$active_value",
				'U_DELETE'					=> $this->u_action . "&amp;id={$row['feed_id']}&amp;action=delete",
				'U_EDIT'						=> $this->u_action . "&amp;id={$row['feed_id']}&amp;action=edit",
			));

		}
		$db->sql_freeresult($result);

		if (!$last_fid)
		{
			$template->assign_var('S_NO_ITEMS', true);
		}
		else
		{
			$s_options = '';
			$_options = array('activate' => 'ACTIVATE', 'deactivate' => 'DEACTIVATE', 'delete' => 'DELETE', 'import' => 'IMPORT');
			foreach ($_options as $value => $lang)
			{
				$s_options .= '<option value="' . $value . '">' . $user->lang[$lang] . '</option>';
			}

			$template->assign_vars(array(
				'S_FEED_OPTIONS'	=> $s_options,
				'U_ACTION'			=> $this->u_action,
			));
		}
	}
}

?>
